*  ͻ  *
*   T3-Net1:     T3FOPEN (c) 1987 TECH III, INC. All rights reserved.      *
*  ͼ  *

** <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> **
**                                                                          **
**  Network file opening utility program                                    **
**                                                                          **
**  This is a proprietary Tech III product that may have                    **
**  been modified for use in this application.                              **
**                                                                          **
**  You may acquire the right to compile and include these utilities as     **
**  part of an unlimited number of larger applications by paying a license  **
**  fee of  $ 95.00 to Tech III.  You may not resell or publish this utility**
**  as part of a set of utilities or in competition with Tech III.  These   **
**  utilities may be distributed for evaluation at no charge or on a disk   **
**  that is sold for no more than $ 5.00.                                   **
**                                                                          **
**  Simple as they may seem, these utilities took quite a bit of blood,     **
**  sweat, and tears to develop.  Go ahead and share them for evaluation,   **
**  learning, etc, but please keep these headers intact, and if you like    **
**  the utilities, support us in doing more of this by paying for them.     **
**                                                                          **
**  You can reach Tech III at: 255 W. 5th St. // San Pedro, CA   90731      **
**  You can pay by credit card (AE,MC,V): 800-543-9941 outside California   **
**                                        213-547-2191 inside  California   **
**                                                                          **
** <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> **

parameters FILENAME, ALIASNAME, REQUEST
* Never use the USE statement: call T3FOPEN instead.
*
* FILENAME   = File you want to open.
* ALIASNAME  = Alias to use
* REQUEST    = 'E' = Exclusive
*              'S' = Shared
*
* Note:  On our systems, we establish global variables called EXLUSIVE
*        and SHARED, and store 'E' and 'S' to them respectively.  That
*        way, a typical call to T3FOPEN would look like the example.
*
* Note:  You must have a GLOBAL variable called SUCCESS.  You must test
*        it every time you call T3FOPEN to see if you "got" the file
*        you wanted.
*
* Note:  Don't forget to run MS-DOS SHARE command before loading FOX.
*
* Note:  T3FOPEN could be but isn't more sophisticated about the exact
*        *type* of error it runs into when it can't open a file.
*        It just tells the user that the file was unavailable for use.
*        It could be modified to distinguish between a non-existent
*        file and a file that is locked by some other user.  However,
*        it is easier to test the way it is:  to see how well your
*        program handles *not* getting access to a file, see the next
*        note.
*
* Note:  To get an idea of what happens when a file is unavailable for
*        requested shared or exlusive use, try calling T3FOPEN with the
*        name of a non-existent file.

* EXAMPLE SHOWING USAGE OF T3FOPEN:
*
*        do T3FOPEN with A_FILE, AN_ALIAS, SHARED
*        if .not. SUCCESS
*          close data
*          return
*        endif
*
store sys(2001,'EXCLUSIVE') to EXCLSV_SET
store .t. to INT3FOPEN
do while INT3FOPEN
  store 0 to ATTEMPTS
  store .f. to SUCCESS
  do case
  case REQUEST = 'S'
    store 'SHARED   ' to REQDESC
    set exclusive off
    store 'File: ' + FILENAME + ' was not available for shared use.' ;
    to message
  case REQUEST = 'E'
    store 'EXCLUSIVE' to REQDESC
    set exclusive on
    store 'File: ' + FILENAME + ' was not available for exclusive use.' ;
    to message
  otherwise
    store 'PROGRAM ERROR: T3FOPEN request must start with an E or S.' ;
    to message
    store .f. to INT3FOPEN
    store .f. to SUCCESS
    loop
  endcase
  on error do T3RETRY with message
  store .t. to SUCCESS
  if len(trim(ALIASNAME)) = 0
    use &FILENAME.
  else
    use &FILENAME. alias &ALIASNAME.
  endif
  on error
  set exclusive &EXCLSV_SET
  if SUCCESS
    store FILENAME + ' successfully opened.' to message
    store .f. to INT3FOPEN
  else
    use
    @ 24,00
    @ 24,00 say 'Do you want to try again? ' get INT3FOPEN pict 'Y'
    read
    @ 24,00
  endif
enddo
return
* EOF
